unit ComCombo;


interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes,
  Graphics, Controls, Forms, Dialogs,stdctrls;

type
  TComCombo = class(TComboBox)

  private
    FAutoTest : boolean;
    MyBitmap:TBitmap;
    function GetComm: integer;
    procedure SetComm(AComm:integer);


  protected

    function  Test(APort:byte):boolean;virtual;
    procedure DropDown;override;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState);override;


  public
    constructor Create(AOwner:TComponent);override;
    destructor  Destroy;override;

    property    Comm : integer read GetComm write SetComm;

  published
    property    AutoTest : boolean read FAutoTest write FAutoTest default true;

end;

procedure Register;


implementation

{$IFDEF Win32}
   {$R ComCombo.R32}
{$ELSE}
   {$R ComCombo.R16}
{$ENDIF}


constructor TComCombo.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FAutoTest := true;
  MyBitmap:=TBitmap.Create;
  MyBitmap.Handle:=LoadBitmap(HInstance,'COMPORT');
  Font.Height:=15;
  ItemHeight:=15;
  Style:=csOwnerDrawFixed;
end;






function  TComCombo.Test(APort:byte):boolean;
     var Ch:array[1..4] of char;
         Res:longint;
     begin
     try
        StrPCopy(@Ch,'COM'+Chr(48+APort)+#0);
        {$IFDEF Win32}
        Res:=CreateFile(@Ch,Generic_Read or Generic_Write,0,nil,Open_Existing,File_Attribute_normal or File_Flag_Overlapped,0);
        {$ELSE}
        Res:=OpenComm(@Ch,256,256);
        {$ENDIF}
        Result:=Res >= 0;
        {$IFDEF Win32}
        if Res >= 0 then CloseHandle(Res);
        {$ELSE}
        if Res >= 0 then CloseComm(Res);
        {$ENDIF}
     except ;
     end;
     end;






procedure TComCombo.DropDown;
     var i:byte;
     begin
     inherited DropDown;
     Items.Clear;
     for i:=1 to 8 do
         if not AutoTest then
            Items.Add('Com'+IntToStr(i))
            else
            if Test(i) then Items.Add('Com'+IntToStr(i));
     end;






destructor TComCombo.Destroy;
begin
  MyBitmap.Free;
  inherited Destroy;
end;





function TComCombo.GetComm: integer;
begin
     if Text='' then Result:=0 else Result:=StrToInt(Text[4]);
end;




procedure TComCombo.SetComm(AComm:integer);
    var i:integer;
    begin
    DropDown;
    for i:=0 to Items.Count-1 do
        if StrToInt(Items[I][4])=AComm then begin
           ItemIndex:=i;
           Text:=Items[ItemIndex];
           Exit;
           end;
    raise Exception.Create(Format('Port COM%d nelze piadit.',[AComm]));
    end;




procedure TComCombo.DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState);
     begin
     {}
     with Canvas do begin
          FillRect(ARect);
          ARect.Right:=ARect.Left+MyBitmap.Width;
          ARect.Bottom:=ARect.Top+MyBitmap.Height;
          BrushCopy(ARect,MyBitmap,Rect(0,0,MyBitmap.Width,MyBitmap.Height),MyBitmap.Canvas.Pixels[0,MyBitmap.Height-1]);
          TextOut(ARect.Left+MyBitmap.Width+5,ARect.Top,Items[Index]);
          end;
     end;



(*         REGISTER          REGISTER         REGISTER            REGISTER       *)
procedure Register;
begin
  RegisterComponents('Eskon',[TComCombo]);
end;






end.


